"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (ast, strictCode, env, realm, labelSet) {
  var body = ast.body,
      test = ast.test;

  // 1. Let V be undefined.

  var V = realm.intrinsics.undefined;

  // 2. Repeat
  while (true) {
    // a. Let stmt be the result of evaluating Statement.
    var stmt = env.evaluateCompletion(body, strictCode);

    // b. If LoopContinues(stmt, labelSet) is false, return Completion(UpdateEmpty(stmt, V)).
    if ((0, _ForOfStatement.LoopContinues)(realm, stmt, labelSet) === false) {
      (0, _invariant2.default)(stmt instanceof _completions.AbruptCompletion);
      // ECMA262 13.1.7
      if (stmt instanceof _completions.BreakCompletion) {
        if (!stmt.target) return (0, _index2.UpdateEmpty)(realm, stmt, V).value;
      }
      throw (0, _index2.UpdateEmpty)(realm, stmt, V);
    }

    // c. If stmt.[[Value]] is not empty, let V be stmt.[[Value]].
    var resultValue = (0, _ForOfStatement.InternalGetResultValue)(realm, stmt);
    if (!(resultValue instanceof _index.EmptyValue)) V = resultValue;

    // d. Let exprRef be the result of evaluating Expression.
    var exprRef = env.evaluate(test, strictCode);

    // e. Let exprValue be ? GetValue(exprRef).
    var exprValue = (0, _index2.GetValue)(realm, exprRef);

    // f. If ToBoolean(exprValue) is false, return NormalCompletion(V).
    if ((0, _index2.ToBooleanPartial)(realm, exprValue) === false) return V;
  }

  (0, _invariant2.default)(false);
};

var _index = require("../values/index.js");

var _index2 = require("../methods/index.js");

var _ForOfStatement = require("./ForOfStatement.js");

var _completions = require("../completions.js");

var _invariant = require("../invariant.js");

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
//# sourceMappingURL=DoWhileStatement.js.map