"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (realm, obj) {
  // ECMA262 19.3.1
  obj.$BooleanData = realm.intrinsics.false;

  // ECMA262 19.3.3.3
  obj.defineNativeMethod("toString", 0, function (context) {
    // 1. Let b be ? thisBooleanValue(this value).
    var b = (0, _to.thisBooleanValue)(realm, context);

    // 2. If b is true, return "true"; else return "false".
    return new _index.StringValue(realm, b.value ? "true" : "false");
  });

  // ECMA262 19.3.3.4
  obj.defineNativeMethod("valueOf", 0, function (context) {
    // 1. Return ? thisBooleanValue(this value).
    return (0, _to.thisBooleanValue)(realm, context);
  });
};

var _index = require("../../values/index.js");

var _to = require("../../methods/to.js");
//# sourceMappingURL=BooleanPrototype.js.map