"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (realm) {
  // ECMA262 22.1.3.30
  return new _index.NativeFunctionValue(realm, "Array.prototype.values", "values", 0, function (context) {
    // 1. Let O be ? ToObject(this value).
    var O = (0, _index2.ToObject)(realm, context.throwIfNotConcrete());

    // 2. Perform ? ValidateTypedArray(O).
    (0, _typedarray.ValidateTypedArray)(realm, O);

    // 3. Return CreateArrayIterator(O, "value").
    return (0, _index2.CreateArrayIterator)(realm, O, "value");
  });
};

var _index = require("../../values/index.js");

var _index2 = require("../../methods/index.js");

var _typedarray = require("../../methods/typedarray.js");
//# sourceMappingURL=TypedArrayProto_values.js.map